<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Fetch Samples</title>

    <!-- CDN of bootstrap -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <script src="https://kit.fontawesome.com/887a516220.js" crossorigin="anonymous"></script>
    

</head>

<body>
    <div class="container">

        <h1>Samples of fetching data with GET method</h1>

        <h2>Please first start the JSON-SERVER</h2>
    <ol>
        <li>Open your terminal or GitBash Console o CMD windows console</li>
        <li>Change to storage directory to start json server</li>
        <li>pwd must be ${USER}\Documents\ceneti\mise-en-place-fundamentos-201909\storage</li>
        <li>In that directory execute from command line json-server --watch employeesDb.json</li>
        <li>Verify the server is started</li>
        <li>in a Browser open http://localhost:3000/employees and the and you must see the Json Array of Employees </li>
        <li>Please, use Postman to verify your POST, GET, PUT and DELETE operations</li>
    </ol>

    <h3>Instructions</h3>
    <ol>
        <li>Star JSON-SERVER</li>
        <li>Clik each button to get data by feching some resource</li>
    </ol>

       <!-- This class its like a table rows and col like table columns -->     
        <div class="row">

            <!-- Column with  button and container -->
            <div class="col-4">
                <button id="txtMsgBtn" class="btn btn-primary" >Get TXT Message </button>                
            </div>
            <div class="col-8">
                <div id="txtMsgContainer"></div>
            </div>
            <!-- lika a break row -->
            <div class="w-100"></div>            

            <!-- Column with  button and container -->
            <div class="col-4">
                <button id="jsonEmployeeBtn" class="btn btn-secondary">Get JSON Employees</button>
            </div>
            <div class="col-8">
                <div id="jsonEmployeesContainer"></div>       
            </div>
            <div class="w-100"></div>

            <!-- Column with  button and container -->
            <div class="col-4">
                <button id="seviceUsersBtn" class="btn btn-success" >Get Users By Service</button>
            </div>
            <div class="col-8">
                <div id="usersContainer"></div>
            </div>
            <div class="w-100"></div>

            <!-- Column with  button and container -->
            <div class="col-4">
                <button id="fetchByServerBtn" class="btn btn-info" >Get Employees by DB</button>
            </div>
            <div class="col-8">
                <div id="employeeContainer" ></div>
            </div>
            <div class="w-100"></div>
        </div>       

    </div>
   
</body>

<script>


    /**
     *
     *
     */
    function fetchTxtMessage() {
        console.log('Get message from TXT Resource');

        fetch('resources/message.txt')
            .then(response => response.text())
            .then((txtData) => {
                console.log(`The txt message is ${txtData}`);
                document.getElementById('txtMsgContainer').innerHTML = txtData;
            })
            .catch(error => {
                console.log(`Some error to Read the resource`);
            })

    }

    
    function fetchJsonEmployees() {
        console.log('Fetching employees by json file');

        fetch('resources/employees.json')
            .then(response => response.json())
            .then(jsonResponse => {
                console.log('The response is ', jsonResponse);

                const employees = jsonResponse.employees;
                console.log('employees are ', employees);

                let row = '';
                const rowArray = [];

                employees.forEach(current => {
                    console.log('current is ', current);
                    row = `<tr>
                                <td>${current.id}</td>
                                <td>${current.first_name}</td>
                                <td>${current.last_name}</td>
                                <td>${current.email}</td>
                            </tr>`;
                    rowArray.push(row);

                    console.log('row ' , row )

                });

                console.log( "####", rowArray.join('') );

                const tableArray = [
                    `<table class="table table-bordered table-dark" id="employeesTable">
                        <thead>
                        <tr>
                            <th>id</th>
                            <th>First Name</th>
                            <th>Last Name</th>
                            <th>Email</th>
                        </tr>
                        </thead>
                        <tbody id="tBodyEmployees">`
                ].concat( rowArray );

                tableArray.push(`</tbody></table>`);

                const jsonEmployeesContainer = document.getElementById('jsonEmployeesContainer');
                jsonEmployeesContainer.innerHTML = tableArray.join('');
            })
            .catch(error => {
                console.error('### Error is: ', error);
            })

    }

    
    function fetchUsersByService() {

        const USERS_URL = 'https://jsonplaceholder.typicode.com/users';

        fetch( USERS_URL )
            .then(response => response.json())
            .then(jsonResponse => {
                console.log(`Size is ${jsonResponse.length}`);

                let row = '';
                const rowArray = [];

                jsonResponse.forEach(current => {
                    row = `<tr>
                            <td>${current.id}</td>
                            <td>${current.name}</td>
                            <td>${current.username}</td>
                            <td>${current.address.zipcode}</td>
                            <td>${current.address.city}</td>
                            <td>${current.address.geo.lat}</td>
                            </tr>`;
                    rowArray.push(row);
                });

                const tableArray = [`<table class="table" id="usersTable">
                                        <thead>
                                        <tr>
                                            <th>id</th>
                                            <th>Name</th>
                                            <th>User name</th>
                                            <th>Zip Code</th>
                                            <th>City</th>
                                            <th>Latitude</th>
                                        </tr>
                                        </thead>
                                        <tbody id="userTBody">`].concat( rowArray );
                
                tableArray.push(`</tbody></table>`);                        
                
                
                const usersContainer = document.getElementById('usersContainer');
                usersContainer.innerHTML = tableArray.join('');

            })
            .catch(error => {
                console.error('## Error is ', error);
            })

    }

    /* Define a const to store the URL */
    const EMPLOYEE_URL_SERVER = "http://localhost:3000/employees";

    /**
     * 1) Execute the fetch to the local json-server
     * 2) The fetch uses one argument, the URL (EMPLOYEE_URL_SERVER)
     * 3) If the response is successfull, then transform the response (the promise) in a JSON object to manipulate the information
     * 4) If convert to JSON is sucessful, then we manipulate the data, generaly to modify the DOM (the web page)
     * 5.1) In this case, create a table, each row will be an item of the response.
     * 6) If some error occurs, we send an alert with a message 
     */
    function fetchEmployeesByDB() {
        console.log('Fetching employees by json server');

        fetch( EMPLOYEE_URL_SERVER )
            .then(response => response.json())
            .then(jsonResponse => {
                console.log('The response is ', jsonResponse);

                let row = '';
                const rowArray = [];

                jsonResponse.forEach(current => {
                    console.log('current is ', current);
                    row = `<tr>
                                <td>${current.id}</td>
                                <td>${current.first_name}</td>
                                <td>${current.last_name}</td>
                                <td>${current.email}</td>
                            </tr>`;
                    rowArray.push(row);

                });

                const tableArray = [ `<table class="table" id="dbEmployeesTable">
                                      <thead>
                                       <tr>
                                           <th>id</th>
                                           <th>First Name</th>
                                           <th>Last Name</th>
                                          <th>Email</th>
                                          </tr>
                                      </thead>
                                     <tbody id="dbBody">`, ...rowArray, `</tbody></table>` ];


                const employeeContainer = document.getElementById('employeeContainer');
                employeeContainer.innerHTML = tableArray.join('');

            })
            .catch(error => {
                console.error('### Error is: ', error);
                alert('Please, check if JSON-Server is started. Error is: ' + error );
            })

    }



    // Define an object and change their onclick method
    const txtMsgBtn = document.getElementById('txtMsgBtn');
    txtMsgBtn.onclick = fetchTxtMessage;


    // Bind a function to click event listener    
    document.getElementById('jsonEmployeeBtn').addEventListener('click', fetchJsonEmployees);


    // We bind the clearForm function to the click event of cleanBtn button
    const seviceUsersBtn = document.getElementById('seviceUsersBtn');
    seviceUsersBtn.onclick = fetchUsersByService;


    // We bind the clearForm function to the click event of cleanBtn button
    document.getElementById('fetchByServerBtn').addEventListener('click', fetchEmployeesByDB);
    

</script>

</html>